#ifndef OBJECTS_H
#define OBJECTS_H

#include <string>
#include <vector>
#include <QImage>
#include "../common/sources/system/cmaths.h"
#include "../common/sources/Map.h"

#define OBJECT_TYPE_TORCH   3
#define OBJECT_TYPE_SCROLL  105

#define TORCH_MAX_CHARGES   114360

class CObjects
{
public:
    struct CObjectInfo
    {
        std::string name;
        QString     category;
        QString     floorImage;
        QString     imageFile;
        uint8_t     imageNum;
        QString     positions;
        int         weight;
        int         combo;
    };

    CObjects();

    void    readObjectsDB();
    void    drawBackRow(QImage* image, CVec2 mapPos, CVec2 tablePos);
    void    drawFrontRow(QImage* image, CVec2 mapPos, CVec2 tablePos);
    void    drawObjectsStack(QImage* image, CVec2 mapPos, EWallSide side, CVec2 tablePos);
    void    setDefaultParams(CObject* obj);

    std::vector<CObjectInfo>    mObjectInfos;

private:
    CVec2   getObjectPos(CVec2 tablePos);
    CVec2   getAlcovePos(CVec2 tablePos);
    bool    isWallInFront();
};

extern CObjects objects;

#endif // OBJECTS_H
